#!/usr/bin/perl

# import required modules

use XML::Simple;
use XML::DOM;
use Data::Dumper;

# Basic adult content filtering, searches genre string for words: adult, porn or xxx
# Per sept 2007 no false matches, hope it stays that way
# Set to 0 to remove adult content from the stream list (default)
# Set to 1 to show all content
my $allowporn = 0;

my $url     = "http://yp.shoutcast.com/sbin/newtvlister.phtml"; #$in[0];
my $xmlfile = "shoutcast/shoutcasttv";
#my $xmlfile = "list.xml";

&read_parse();    # get commandline parameters into @in


# fetch only if "$xmlfile.xml" with shoutcast newtvlister data is >=1 day old
# (server doesn't check if-modified-since http header sent by mythstream)
if ( int(-M "$xmlfile.xml") >= 1 || ! -e "$xmlfile.xml" )
{
	# create user agent
	use LWP::UserAgent;
	$ua = LWP::UserAgent->new;
	$ua->agent("mozilla/0.1 ");
	my $head = new HTTP::Headers;

	# request
	my $req = HTTP::Request->new(get => $url);
	$req->content_type('application/x-www-form-urlencoded');
	$req->content('match=www&errors=0');

	# fetch
	my $res = $ua->request($req);

	# process response
	if (! $res->is_success)
	{
			print "error fetching $xmlfile.xml\n";
	}
		else
	{
		open ( DST, ">$xmlfile.xml") || die "$xmlfile.xml cannot be opened for writing\n";
		print DST $res->content . "\n";
		close (DST);

		# Fetch genres. Unused for now, sctv's genre list is a mess.
		$xml = new XML::Simple();

		eval{ $data = $xml->XMLin($res->content); };

		my $k = $data->{'station'};

		open ( DST, ">$xmlfile.genres") || die "$xmlfile.genres cannot be opened for writing\n";
		foreach my $entry ( keys %$k )
		{
			$genre = $data->{'station'}->{$entry}->{'genre'};
			
			if ($showporn == 1 || !($genre =~ /Adult|Porn|XXX/i) )
			{
			  print DST $genre . "\n";
			}
		}
		close (DST);
	}

}

$xml = new XML::Simple();

my $doc = XML::DOM::Document->new;
my $head = $doc->createXMLDecl ('1.0');
my $root = $doc->createElement('items');

sub newNode
{
	local $name  = shift;
	local $value = shift;
	local $node = $doc->createElement($name);
	local $text = $doc->createTextNode($value);
	$node->appendChild($text);

	return $node;
}

sub checkNode
{
	local $node = shift;
	return ( $node && !($node =~ /^HASH/) )  # deref empty hash element
}

sub addMetaNode
{
	local $node  = shift;
	local $name  = shift;
	local $type  = shift;

	if ( checkNode($node) )
	{
		if ($type eq '')
		{
		$type = "inline";
		if ($node =~ /\n/)           { $type = "text" }
		if ($node =~ /<.+>.+<\/.+>/) { $type = "html" }
		}
		
		$meta = $doc->createElement('meta');
		$meta->appendChild( newNode('name'   , $name) );
		$meta->appendChild( newNode('content', $node) );
		$meta->appendChild( newNode('viewer' , $type) );
		$item->appendChild( $meta );
	}
}

sub parseItem
{
	local $entry = shift;
	local $k = $data->{'station'}->{$entry};

	my $genre = $k->{'genre'};
	
	if ($allowporn == 1 || !($genre =~ /Adult|Porn|XXX/i))
	{
		$item = $doc->createElement('item');
		$item->appendChild( newNode('name'   , $entry) );
		$item->appendChild( newNode('url'    , 'http://yp.shoutcast.com/sbin/tunein-tvstation.pls?id=' . $k->{id}) );
		$item->appendChild( newNode('descr'  , $k->{'genre'}) );
		$item->appendChild( newNode('handler', 'test') );
		$root->appendChild($item);

		addMetaNode($k->{genre}, 'genre', 'inline');
	}
}


#------------------------------------------------------------------------------
# Init and Run
#------------------------------------------------------------------------------

eval{ $data = $xml->XMLin("$xmlfile.xml"); };

# print Dumper($data);
# exit;
my $k = $data->{'station'};

foreach my $entry ( keys %$k ) { parseItem($entry); }

print $head->toString;
print $root->toString;
print "\n";


#--------------------------------------------------------------------------------
# get command line parameters
#--------------------------------------------------------------------------------

sub read_parse {
local (*in) = @_ if @_;
local ($i);
push(@in, @ARGV);
foreach $i (0 .. $#in) { $in[$i] =~ s/\+/ /g;}
return scalar(@in);
}


