#! /usr/bin/perl
#* ============================================================
# * File  : podcast.pl
# * Author: Eric 
# * Date  : 2004-10-31
# * Description : iPodder XML list parser for streamtuned / mythstream
# *               test XML: http://www.wholewheatradio.org/jbb/WWR_comedy.xml
# * Not efficient, please improve.
# * takes subset of fields, see http://blogs.law.harvard.edu/tech/rss
# * ============================================================ */

use English;
use XML::Simple;
use XML::DOM;
use Data::Dumper;


$xml = new XML::Simple;

my $doc = XML::DOM::Document->new;
my $head = $doc->createXMLDecl ('1.0');
my $root = $doc->createElement('items');

sub newNode
{
  local $name  = shift;
  local $value = shift;
  local $node = $doc->createElement($name);
  local $text = $doc->createTextNode($value);
  $node->appendChild($text);
  
  return $node;
}

sub checkNode
{
   local $node = shift;   
   return ( $node && !($node =~ /^HASH/) )  # deref empty hash element
}

sub addMetaNode
{
  local $node  = shift;
  local $name  = shift;
  local $type  = shift;
  
  if ( checkNode($node) )
  {
   if ($type eq '')
   {
     $type = "inline";
     if ($node =~ /\n/)           { $type = "text" }
     if ($node =~ /<.+>.+<\/.+>/) { $type = "html" }
   }
   
   $meta = $doc->createElement('meta');
   $meta->appendChild( newNode('name'   , $name) );
   $meta->appendChild( newNode('content', $node) );
   $meta->appendChild( newNode('viewer' , $type) );
   $item->appendChild( $meta );
  }
}

sub parseItem
{
  local $entry = shift;
  
  if ($entry->{link})
  {
    $item = $doc->createElement('item');
    $item->appendChild( newNode('name'   , $entry->{title}) );
    $item->appendChild( newNode('url'    , $entry->{link}) );
    $item->appendChild( newNode('descr'  , $entry->{pubDate}) );
    $item->appendChild( newNode('handler', 'tvlinks/listing') );
    $root->appendChild($item);
  }
}

#------------------------------------------------------------------------------
# Init and Run
#------------------------------------------------------------------------------

&read_parse();    # get commandline parameters into @in
$source = $in[0]; # source filename from command line

eval{ $data = $xml->XMLin($source); };


$channel = $data->{channel};

# print Dumper($channel->{item});

if ( ref($channel->{item}) eq 'ARRAY' )
{
  foreach my $entry (@{$channel->{item}}) { parseItem($entry); }
}
  else
{
  parseItem($channel->{item});
}

print $head->toString;
print $root->toString;
print "\n";

#--------------------------------------------------------------------------------
# get command line parameters
#--------------------------------------------------------------------------------

sub read_parse {
  local (*in) = @_ if @_;
  local ($i);
  push(@in, @ARGV);
  foreach $i (0 .. $#in) { $in[$i] =~ s/\+/ /g;}
  return scalar(@in);
}


